/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner{}

// GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner struct for GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner
type GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner struct {
	Description *string `json:"description,omitempty"`
	Lang *string `json:"lang,omitempty"`
	Type *string `json:"type,omitempty"`
}

// NewGetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner instantiates a new GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner() *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner {
	this := GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner{}
	return &this
}

// NewGetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInnerWithDefaults instantiates a new GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInnerWithDefaults() *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner {
	this := GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner{}
	return &this
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) GetDescription() string {
	if o == nil || IsNil(o.Description) {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) GetDescriptionOk() (*string, bool) {
	if o == nil || IsNil(o.Description) {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) HasDescription() bool {
	if o != nil && !IsNil(o.Description) {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) SetDescription(v string) {
	o.Description = &v
}

// GetLang returns the Lang field value if set, zero value otherwise.
func (o *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) GetLang() string {
	if o == nil || IsNil(o.Lang) {
		var ret string
		return ret
	}
	return *o.Lang
}

// GetLangOk returns a tuple with the Lang field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) GetLangOk() (*string, bool) {
	if o == nil || IsNil(o.Lang) {
		return nil, false
	}
	return o.Lang, true
}

// HasLang returns a boolean if a field has been set.
func (o *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) HasLang() bool {
	if o != nil && !IsNil(o.Lang) {
		return true
	}

	return false
}

// SetLang gets a reference to the given string and assigns it to the Lang field.
func (o *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) SetLang(v string) {
	o.Lang = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) SetType(v string) {
	o.Type = &v
}

func (o GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Description) {
		toSerialize["description"] = o.Description
	}
	if !IsNil(o.Lang) {
		toSerialize["lang"] = o.Lang
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	return toSerialize, nil
}

type NullableGetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner struct {
	value *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner
	isSet bool
}

func (v NullableGetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) Get() *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner {
	return v.value
}

func (v *NullableGetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) Set(val *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) {
	v.value = val
	v.isSet = true
}

func (v NullableGetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) IsSet() bool {
	return v.isSet
}

func (v *NullableGetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner(val *GetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) *NullableGetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner {
	return &NullableGetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner{value: val, isSet: true}
}

func (v NullableGetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetCveRecordResponseContainersCnaProblemTypesInnerDescriptionsInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


